/* This file is part of the CUMODP library

    CUMODP is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    CUMODP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CUMODP.  If not, see <http://www.gnu.org/licenses/>.

    Copyright: Sardar Anisul Haque <shaque4@uwo.ca>
               Xin Li <xli.software@gmail.com>
               Farnam Mansouri <mansouri.farnam@gmail.com>
               Davood Mohajerani <dmohajer@uwo.ca>
               Marc Moreno Maza  <moreno@csd.uwo.ca>
               Wei Pan <wei.pan@intel.com>
               Ning Xie <nxie6@csd.uwo.ca>
*/




/*! \mainpage Documentation for CUMODP Library
 *
 * \section intro_sec Introduction
 *
 * CUMODP library is a C++ library with CUDA support for polynomial arithmetic over finite field. 
 *
 * \section install_sec Installation
 * 
 * We need to describe how we can install cumodp on machines.
 *
 * \subsection division Cuda Division
 *  
 * <a href="cuda_div_8cu.html#divCPU"> main division operation </a>
 * \subsection gcd Cuda Gcd
 *  
 * <a href="cuda_gcd_8cu.html#gcdCPU"> main gcd operation </a>
 * \subsection mul Cuda Multiplication
 *  
 * <a href="opt__plain__mul_8cu.html#multiCPU"> main multiplication operation </a>
 * \subsection eva Cuda Polynomial Evaluation
 *  
 * <a href="fast_poly_evaluation_8cu.html#evaCPU"> main Cuda Polynomial Evaluation </a>
 * \section how_sec Using the Documentation
 *
 * 
 */
